//+------------------------------------------------------------------+
//|                                                       TDI EA.mq4 |
//|                              Copyright 2017, Besarion Turmanauli |
//|                       https://www.mql5.com/en/users/tobeone/blog |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, Besarion Turmanauli"
#property link      "https://www.mql5.com/en/users/tobeone/blog"
#property version   "1.3"
#property strict
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum enum_entry
  {
   method1,//method 1 (stochastic 20%)
   method2 //method 2 (stochastic 50%)
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum enum_stoploss
  {
   stoploss_signalbar,//below/above the signal bar
   stoploss_samesize, //same size as takeprofit
   stoploss_prevbar //below/above the previous bar
  };

input enum_entry entry_method=method1;
input enum_stoploss stop_method=stoploss_prevbar;
input double signal_strength = 1.5; 
input double fixed_lots=0.01;
input int hl_multiplier= 3;
input int magic=11111;
input string comment="TDI";
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
datetime last=0;
int sells,buys;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
   if(AccountNumber()!=706766){Alert("Wrong Account Number! Expert Will Now Be Removed!");ExpertRemove();}
//--- create timer
   EventSetTimer(60);//60 seconds = 1 minute; 60*5 = 5 minutes

   Print("Verifying if indicators are loaded (current instrument)...");
   Print("Stochastic: "+(string)iStochastic(Symbol(),Period(),14,3,3,MODE_SMA,STO_CLOSECLOSE,MODE_MAIN,1));
   Print("TDI Yellow: "+(string)iCustom(Symbol(),Period(),"TDI_RT alerts + divergence",
         13,0,34,2,0,7,0,
         false,false,false,
         false,false,false,
         "alert2.wav",false,
         true,true,1,4.0,4.0,
         true,true,clrLimeGreen,clrOrangeRed,
         233,234,159,159,"tdi divergence1",
         1,1));
//---
   if(!IsTesting() && !IsOptimization() && !IsVisualMode())
     {
      if(//adding core pairs
         SymbolSelect("USDJPY",true) && 
         SymbolSelect("GBPCHF",true) && 
         SymbolSelect("GBPUSD",true) && 
         SymbolSelect("USDCHF",true) && 
         SymbolSelect("GBPAUD",true)
         ){Print("Instruments added successfully!");}else{Alert("Couldn't add core pairs to Market Watch. Expert will be removed.");ExpertRemove();}
     }//if live or demo

   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- destroy timer
   EventKillTimer();

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {

   if(IsTesting() || IsVisualMode() || IsOptimization())main_function(Symbol(),hl_multiplier);

  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---
   if(!IsTesting() && !IsOptimization() && !IsVisualMode())
     {
      main_function("USDJPY",3);
      main_function("GBPCHF",2);
      main_function("GBPUSD",3);
      main_function("USDCHF",3);
      main_function("GBPAUD",3);
     }//end if not testing

  }
//+------------------------------------------------------------------+

void main_function(string local_instrument,int local_hl_multiplier)
  {

   if(iTime(local_instrument,Period(),1)>last)
     {//execute this code on each close
      RefreshRates();
      //---
      //first of all we need ontick strategy, simple and working one, with simple dynamic entries
      //and exits..

      //--- COUNT AVERAGE H-L FOR DYNAMIC EXECUTION
      double average_hl=NormalizeDouble(
                                        (
                                        (iHigh(local_instrument,Period(),1)-iLow(local_instrument,Period(),1))+
                                        (iHigh(local_instrument,Period(),2)-iLow(local_instrument,Period(),2))+
                                        (iHigh(local_instrument,Period(),3)-iLow(local_instrument,Period(),3))+
                                        (iHigh(local_instrument,Period(),4)-iLow(local_instrument,Period(),4))+
                                        (iHigh(local_instrument,Period(),5)-iLow(local_instrument,Period(),5))
                                        )/5,(int)MarketInfo(local_instrument,MODE_DIGITS));
      //--- END OF COUNTING AVERAGE H-L

      double stoch_main=iStochastic(local_instrument,Period(),14,3,3,MODE_SMA,STO_CLOSECLOSE,MODE_MAIN,1);
      double tdi_red=iCustom(local_instrument,Period(),"TDI_RT alerts + divergence",
                             13,0,34,2,0,7,0,
                             false,false,false,
                             false,false,false,
                             "alert2.wav",false,
                             true,true,1,4.0,4.0,
                             true,true,clrLimeGreen,clrOrangeRed,
                             233,234,159,159,"tdi divergence1",
                             4,
                             1);
      double tdi_yellow=iCustom(local_instrument,Period(),"TDI_RT alerts + divergence",
                                13,0,34,2,0,7,0,
                                false,false,false,
                                false,false,false,
                                "alert2.wav",false,
                                true,true,1,4.0,4.0,
                                true,true,clrLimeGreen,clrOrangeRed,
                                233,234,159,159,"tdi divergence1",
                                1,1);
      double tdi_green_s1=iCustom(local_instrument,Period(),"TDI_RT alerts + divergence",
                                  13,0,34,2,0,7,0,
                                  false,false,false,
                                  false,false,false,
                                  "alert2.wav",false,
                                  true,true,1,4.0,4.0,
                                  true,true,clrLimeGreen,clrOrangeRed,
                                  233,234,159,159,"tdi divergence1",
                                  3,1);
      double tdi_green_s2=iCustom(local_instrument,Period(),"TDI_RT alerts + divergence",
                                  13,0,34,2,0,7,0,
                                  false,false,false,
                                  false,false,false,
                                  "alert2.wav",false,
                                  true,true,1,4.0,4.0,
                                  true,true,clrLimeGreen,clrOrangeRed,
                                  233,234,159,159,"tdi divergence1",
                                  3,2);


      //SELL IF
      //--> Stochastic is below 20
      //--> Green and Red Bellow Yellow
      //--> Green Crosses Red Down OR Green rebounds down from Red
      if(((entry_method==method1 && stoch_main<20) || (entry_method==method2 && stoch_main<50)) && //stochastic below 20 
         tdi_green_s1<tdi_yellow && tdi_red<tdi_yellow && //green and red below yellow
         tdi_green_s1<tdi_red && tdi_green_s2>=tdi_red && //
         average_hl>0 && 
         OrdersTotal()==0
         )
        {
         //sell
         double sl=0;
         if(stop_method==stoploss_samesize){sl=NormalizeDouble(MarketInfo(local_instrument,MODE_ASK)+average_hl*local_hl_multiplier,(int)MarketInfo(local_instrument,MODE_DIGITS));}
         if(stop_method==stoploss_signalbar){sl=NormalizeDouble(iHigh(local_instrument,Period(),1),(int)MarketInfo(local_instrument,MODE_DIGITS));}
         if(stop_method==stoploss_prevbar){sl=NormalizeDouble(iHigh(local_instrument,Period(),2),(int)MarketInfo(local_instrument,MODE_DIGITS));}

         if((sl-MarketInfo(local_instrument,MODE_ASK))>=average_hl*signal_strength)
           {//if sl is ok
            double tp = NormalizeDouble(MarketInfo(local_instrument,MODE_BID)-average_hl*local_hl_multiplier,(int)MarketInfo(local_instrument,MODE_DIGITS));
            int ticket= 0;
            ticket=OrderSend(Symbol(),OP_SELL,fixed_lots,MarketInfo(local_instrument,MODE_BID),3,0,0,comment,magic,0,clrRed);
            if(ticket>0)
              {
               if(OrderSelect(ticket,SELECT_BY_TICKET))
                 {
                  if(OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,OrderExpiration(),clrRed))
                    {
                     Print("SELL");}else{GetLastError();
                     Print("SL (current/new): "+"("+(string)OrderStopLoss()+"/"+(string)sl+")");
                     Print("TP (current/new): "+"("+(string)OrderTakeProfit()+"/"+(string)tp+")");
                    }
                 }
              }
           }//end if sl is ok 
        }

      //BUY IF
      //--> Stochastic is above 80
      //--> Green and Red above Yellow
      //--> Green Crosses Red Up OR Green rebounds up from Red
      if(((entry_method==method1 && stoch_main>80) || (entry_method==method2 && stoch_main>50)) && //stochastic above 80 
         tdi_green_s1>tdi_yellow && tdi_red>tdi_yellow && //green and red below yellow
         tdi_green_s1>tdi_red && tdi_green_s2>=tdi_red && //
         average_hl>0 && 
         OrdersTotal()==0
         )
        {
         //buy
         double sl=0;
         if(stop_method==stoploss_samesize){sl=NormalizeDouble(MarketInfo(local_instrument,MODE_BID)-average_hl*local_hl_multiplier,(int)MarketInfo(local_instrument,MODE_DIGITS));}
         if(stop_method==stoploss_signalbar){sl=NormalizeDouble(iLow(local_instrument,Period(),1),(int)MarketInfo(local_instrument,MODE_DIGITS));}
         if(stop_method==stoploss_prevbar){sl=NormalizeDouble(iLow(local_instrument,Period(),2),(int)MarketInfo(local_instrument,MODE_DIGITS));}

         if((MarketInfo(local_instrument,MODE_BID)-sl)>=average_hl*signal_strength)
           {//if sl is ok
            double tp = NormalizeDouble(MarketInfo(local_instrument,MODE_ASK)+average_hl*local_hl_multiplier,(int)MarketInfo(local_instrument,MODE_DIGITS));
            int ticket= 0;
            ticket=OrderSend(Symbol(),OP_BUY,fixed_lots,MarketInfo(local_instrument,MODE_ASK),3,0,0,comment,magic,0,clrBlue);

            if(ticket>0)
              {
               if(OrderSelect(ticket,SELECT_BY_TICKET))
                 {
                  if(OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,OrderExpiration(),clrRed))
                    {
                     Print("BUY");}else{GetLastError();
                     Print("SL (current/new): "+"("+(string)OrderStopLoss()+"/"+(string)sl+")");
                     Print("TP (current/new): "+"("+(string)OrderTakeProfit()+"/"+(string)tp+")");
                    }
                 }
              }
           }//end if sl is ok 
        }

      last=iTime(Symbol(),Period(),1);
     }//end interval
  }//end of main function
